/**********************************************************************
 *  This is the beginning of c source file "testNull.c" for linux
 *********************************************************************/


#include "testNull.h"

/* no OS specific vars for linux yet */


/*************************************************************************
 * File operations structure declaration.
 * Function pointers are automatically set to names of functions as the
 * functions are registered in the m4 source.
 *************************************************************************/
struct file_operations testNull_fops = {
  llseek:     testNull_LSEEK,
  read:     testNull_READ,
  write:     testNull_WRITE,
  open:     testNull_OPEN,
  release:     testNull_RELEASE,
};


static int __init testNull_init() {
  int MethodRetval = 0;
  int TaxiRetval;

  printk("testNull: init()\n");
  TaxiRetval = register_chrdev(244, "testNull", &testNull_fops);
  return TaxiRetval;
}

static void __exit testNull_exit() {

  printk("testNull: exit()\n");
  unregister_chrdev(244, "testNull");
}

/* Definitions for registered file operation functions */

static loff_t testNull_LSEEK(struct file *filp, loff_t offset, int orig) {
  return filp->f_pos = 0;
}
static ssize_t testNull_READ(struct file *filp, char *buf, size_t count, loff_t *f_pos) {
  printk("testNull: read()\n");
  return 0;
}
static ssize_t testNull_WRITE(struct file *filp, const char *buf, size_t count, loff_t *f_pos) {
  int TaxiRetval;
  int MethodRetval = 0;

  int i;
  char *kernelSpaceBuffer;
    kernelSpaceBuffer = kmalloc(count, GFP_KERNEL);

  if (!kernelSpaceBuffer) return -ENOMEM;

  TaxiRetval = copy_from_user(kernelSpaceBuffer, buf, count);
  if (TaxiRetval) { /* handle any error that copyin returns */
    kfree(kernelSpaceBuffer);
    return TaxiRetval;
  }

  for (i = 0; i < count; i++) {
    printk("testNull: writing: %c\n", kernelSpaceBuffer[i]);
  }
  kfree(kernelSpaceBuffer);
  

  MethodRetval = i;
  return MethodRetval;
}
static ssize_t testNull_OPEN(struct inode *node, struct file *filp) {
  MOD_INC_USE_COUNT;
  printk("testNull: open()\n");
  return 0;
}
static ssize_t testNull_RELEASE(struct inode *node, struct file *filp) {
  MOD_DEC_USE_COUNT;
  printk("testNull: release()\n");
  return 0;
}
 
MODULE_LICENSE("GPL");
/*********************************************************************
 *  This is the end of c source file "testNull.c" for linux
 *********************************************************************/



module_init(testNull_init);
module_exit(testNull_exit);
